data ToothGrowth ;
  input len supp$ dose ;
  cards ;
   4.2   VC  0.5
  11.5   VC  0.5
   7.3   VC  0.5
   5.8   VC  0.5
   6.4   VC  0.5
  10.0   VC  0.5
  11.2   VC  0.5
  11.2   VC  0.5
   5.2   VC  0.5
   7.0   VC  0.5
  16.5   VC  1.0
  16.5   VC  1.0
  15.2   VC  1.0
  17.3   VC  1.0
  22.5   VC  1.0
  17.3   VC  1.0
  13.6   VC  1.0
  14.5   VC  1.0
  18.8   VC  1.0
  15.5   VC  1.0
  23.6   VC  2.0
  18.5   VC  2.0
  33.9   VC  2.0
  25.5   VC  2.0
  26.4   VC  2.0
  32.5   VC  2.0
  26.7   VC  2.0
  21.5   VC  2.0
  23.3   VC  2.0
  29.5   VC  2.0
  15.2   OJ  0.5
  21.5   OJ  0.5
  17.6   OJ  0.5
   9.7   OJ  0.5
  14.5   OJ  0.5
  10.0   OJ  0.5
   8.2   OJ  0.5
   9.4   OJ  0.5
  16.5   OJ  0.5
   9.7   OJ  0.5
  19.7   OJ  1.0
  23.3   OJ  1.0
  23.6   OJ  1.0
  26.4   OJ  1.0
  20.0   OJ  1.0
  25.2   OJ  1.0
  25.8   OJ  1.0
  21.2   OJ  1.0
  14.5   OJ  1.0
  27.3   OJ  1.0
  25.5   OJ  2.0
  26.4   OJ  2.0
  22.4   OJ  2.0
  24.5   OJ  2.0
  24.8   OJ  2.0
  30.9   OJ  2.0
  26.4   OJ  2.0
  27.3   OJ  2.0
  29.4   OJ  2.0
  23.0   OJ  2.0
 ; 
run ;

proc gplot data=ToothGrowth ;
   plot len * dose = supp ;
run ;

proc sgplot data=ToothGrowth ;
   scatter x=dose y=len / group=supp ;
run ;
quit ;

proc sgplot data=ToothGrowth ;
  scatter  x=dose y=len / group=supp ;
  xaxis    values=(0.5 1 2) min=0.4 max=2.1 
           offsetmin=0.1 offsetmax=0.1 ;
  refline  20 / axis=y lineattrs=(color=black pattern=1);
  keylegend / location=inside position=bottomright ;
run ;
quit ;

*******************************************************************************;

title "1.qXgOƖx" ;
proc sgplot data=sashelp.iris ;
  histogram PetalLength ;
  density   PetalLength / type=kernel ;
run ;

title "2.Ђ}" ;
proc sgplot data=sashelp.iris ;
  vbox PetalLength / category=Species ;
  *--- vbox  hbox ɂƉɂȂ ;
run ;

title "3._Otiϒlj" ;
proc sgplot data=sashelp.iris ;
  vbar  Species / response=PetalLength stat=mean ;
  *--- vxxx  hxxx ɂƉɂȂ ;
run ;

title "4.Uz}Ɗmȉ~" ;
proc sgplot data=sashelp.iris ;
  scatter x=SepalLength y=SepalWidth
 / group=Species ;
  ellipse x=SepalLength y=SepalWidth ;
run ;

title "5.hbgvbg" ;
proc sgplot data=sashelp.iris ;
  dot Species / response=PetalLength
    stat=mean limitstat=stddev ;
run ;

title "6.Waterfall Plot" ;
data ResponseRate ;
  input id rrate result$ @@ ;
  cards ;
   1  80 PD   2  50 PD   3  40 PD   4  20 PD   5   5 SD   6 -10 SD
   7 -10 SD   8 -15 SD   9 -30 PR  10 -50 PR  11 -60 PR  12 -95 CR
 ; 
run ;

proc sgplot data=ResponseRate ; 
   vbar  id / response=rrate group=result ;
   xaxis display=none ;
   yaxis label='Response Rate (%)' ;
run ;

/*
proc sgplot data=sashelp.iris ; * Waterfall Chart for Business Setting ;
  waterfall category=Species response=SepalLength / stat=mean ;
run;
*/

title ;

*******************************************************************************;

proc format ;
   value dosef 0.5="0.5 mg" 1="1.0 mg" 2="2.0 mg" ;
run ;

proc sgplot data=ToothGrowth ;
  styleattrs
    datacolors      =(blue red)
    datalinepatterns=(1 2)
    datasymbols     =(circlefilled diamondfilled) ; 
  vline dose / response    =len      group =supp
               groupdisplay=cluster  stat  =mean
               limitstat   =stddev   limits=both
               markers ;
  xaxis     type=discrete offsetmin=0.2 offsetmax=0.2 display=(nolabel) tickvalueformat=dosef. ;
  yaxis     values=(10 20 30) min=0 max=40 offsetmin=0.2 offsetmax=0.2 label="Tooth Length (mm)" ; 
  keylegend / down=2 location=inside position=topleft title="Supplement" ;
run ;

*****;

data Line ;
  input function $ x1 y1 x2 y2 shape $ direction $ label $ ;
  cards ;
    arrow 50 20 48 48 barbed out  .
    arrow 50 20 59 35 barbed out  .
    text  50 17  .  .      .   . 1.0mg
  ;

proc sgplot data=ToothGrowth sganno=Line ;
  styleattrs
    datacolors      =(blue red)
    datalinepatterns=(1 2)
    datasymbols     =(circlefilled diamondfilled) ; 
  vline dose / response    =len      group =supp
               groupdisplay=cluster  stat  =mean
               limitstat   =stddev   limits=both
               markers ;
  xaxis     type=discrete offsetmin=0.2 offsetmax=0.2 display=(nolabel) tickvalueformat=dosef. ;
  yaxis     values=(10 20 30) min=0 max=40 offsetmin=0.2 offsetmax=0.2 label="Tooth Length (mm)" ; 
  keylegend / down=2 location=inside position=topleft title="Supplement" ;
run ;
quit ;

*****;

%sganno ; * X̃}NĂяoFڍׂ %sganno_help(all) s ;
data myAnno ;
  %sgarrow(x1=10, x2=20, y1=90, y2=90, linecolor="red", linepattern=2) ;
  %sgimage(x1=15, y1=80, height=5, image="C:\temp\icon.gif") ;
  %sgline (x1=20, x2=30, y1=70, y2=70, linecolor="blue", linepattern=2) ;
  %sgoval (x1=30, y1=60, height=5, width=5, linecolor="green", linepattern=1) ;
  %sgpolygon (x1=35, y1=55, fillcolor="yellow", linecolor="yellow", display="all") ;
  %sgpolycont(x1=35, y1=50) ; * (35,55)(35,50)(40,50) ̏őp`` ;
  %sgpolycont(x1=40, y1=50) ; *  %sgpolyline l̎菇Ń|S` ;
  %sgpolyline(x1=45, y1=45, linecolor="pink") ;
  %sgpolycont(x1=45, y1=40) ; %sgpolycont(x1=50, y1=40) ; %sgpolycont(x1=50, y1=45) ;
  %sgrectangle(x1=60, y1=30, height=5, width=5, linecolor="cyan", fillcolor="white") ;
  %sgtext (x1=80, y1=20, label="XXXXX", textcolor="black", textsize=20, width=15, 
    rotate=30, justify="center") ;
  %sgtextcont(label="yyy", textweight="bold") ;
run ;

proc sgplot data=ToothGrowth sganno=myAnno ;
  scatter x=dose y=len / markerattrs=(color=white) ;
run ;

*****;

proc template ;
   define style styles.XXX ;
     parent=styles.journal ;
/*
     class GraphdataDefault
     / contrastcolor=black linestyle=1 linethickness=1px ;
     class Graphdata1
     / contrastcolor=blue markersymbol="trianglefilled" ;
     class Graphdata2
     / contrastcolor=red foreground=black color=red ;
*/
   end ;
run ;

ods listing style=styles.XXX ;
proc sgplot data=ToothGrowth ;
  styleattrs
    datacolors      =(blue red)
    datalinepatterns=(1 2)
    datasymbols     =(circlefilled diamondfilled) ; 
  vline dose / response    =len      group =supp
               groupdisplay=cluster  stat  =mean
               limitstat   =stddev   limits=both
               markers ;
  xaxis     type=discrete offsetmin=0.2 offsetmax=0.2 display=(nolabel) tickvalueformat=dosef. ;
  yaxis     values=(10 20 30) min=0 max=40 offsetmin=0.2 offsetmax=0.2 label="Tooth Length (mm)" ; 
  keylegend / down=2 location=inside position=topleft title="Supplement" ;
run ;

*******************************************************************************;

data test ;
  do x=-5 to 5 by 0.01 ;
    y=pdf("normal",x,0,1) ; output ;
  end ;
run ;
proc sgplot data=test ;
  series x=x y=y ;
run ;

data test ;
  low  = quantile("normal",0.025) ; *---  2.5%_ ;
  high = quantile("normal",0.975) ; *--- 97.5%_ ;

  do x=-5 to 5 by 0.01 ;
    y=pdf("normal",x,0,1) ;       * WKz̊mx֐ ;
    if x <=  low then a1=y ; else a1=. ; *  2.5%_ȉ̂ݕ` ;
    if x >= high then a2=y ; else a2=. ; * 97.5%_ȏ̂ݕ` ;
    output ;
  end ;
run ;
proc sgplot data=test ;
  series x=x y=y ;                        *--- WKz̊mx֐` ;
  band x=x upper=a1 lower=0 / fillattrs=(color=blue) ; *---  2.5%_ȉ` ;
  band x=x upper=a2 lower=0 / fillattrs=(color=blue) ; *--- 97.5%_ȏ` ;
run ;

*******************************************************************************;

data AML ;
  input Time Status Group @@ ;
  cards ;
    9 1 1   13 1 1   13 0 1   18 1 1   23 1 1
   28 0 1   31 1 1   34 1 1   45 0 1   48 1 1
  161 0 1    5 1 2    5 1 2    8 1 2    8 1 2
   12 1 2   16 0 2   23 1 2   27 1 2   30 1 2
   33 1 2   43 1 2   45 1 2
  ;
run ;

proc format ;
  value groupf 1="Maintained" 2="Non-maintained" ;
run ;

ods output Survivalplot=KM ;
proc lifetest data=AML plots=survival ;
   by   Group ;
   time Time * Status(0) ;
run ;
ods output close ;

proc sgplot data=KM ;
  step    x=Time y=Survival / group=Group ;
  scatter x=Time y=Censored / group=Group ;
  format  Group groupf. ;
run ;

*****;

ods output Survivalplot=KM_TMP ;
proc lifetest data=AML plots=survival(atrisk=0 to 160 by 20) ;
   by   Group ;
   time Time * Status(0) ;
run ;
ods output close ;

data KM ; 
  set KM_TMP ;
  Failure  =100*(1-Survival) ;
  Censored2=100*(1-Censored) ;
run ;

proc sgplot data=KM ;
  styleattrs 
    datacontrastcolors=(red blue)
    datasymbols       =(plus plus) ;
  step    x=Time y=Failure   / group=Group name="x" ;
  scatter x=Time y=Censored2 / group=Group ;
  xaxis   values=(0 to 160 by 20) label="Time";
  yaxis   values=(0 to 100 by 20) label="Cumulative Incidence (%)";
  format  Group groupf. ;
  xaxistable Atrisk / x=tAtrisk class=Group location=inside  colorgroup=Group separator ;
 *xaxistable Atrisk / x=tAtrisk class=Group location=outside colorgroup=Group separator ;
  keylegend "x" / location=inside position=topright;
run ;

*******************************************************************************;

data MYDATA ;
  input GROUP $ CENSOR DAY ;
  cards ;
    A 1 100
    A 2 200
    A 1 300
    A 0 400
    A 1 500
    A 2 600
    B 1 150
    B 0 250
    B 1 350
    B 2 450
    B 1 550
  ;
run ;

proc lifetest data=MYDATA outcif=OUT ;
  strata GROUP ;
  time   DAY*CENSOR(0) / eventcode=1 ;
run ;

proc phreg data=MYDATA ;
  class GROUP (order=internal ref=first) ;
  model DAY*CENSOR(0)=GROUP / eventcode=1 ;
run ;

data DAY50 ;
  GROUP="A" ; do DAY=0 to 600 by 50 ; tAtRisk=Day; output ; end ;
  GROUP="B" ; do DAY=0 to 600 by 50 ; tAtRisk=Day; output ; end ;
run ;

data KM ; 
  retain TMP ;
  merge  OUT DAY50 ;
  by     GROUP DAY ;

  FAILURE=100*CIF ;
  if AtRisk=. then AtRisk = TMP ;
  else             TMP    = AtRisk-AllEventTypes-Censored ;
  keep GROUP DAY FAILURE AtRisk tAtRisk ;
run ;

proc sgplot data=KM ;
  styleattrs 
    backcolor          = lightgray
    datacontrastcolors = (red blue)
    datalinepatterns   = (1 2) ;
  step  x=DAY y=FAILURE / group=GROUP name="GRP" ;
  xaxis values=(0 to 600 by 50) label="Day";
  yaxis values=(0 to 100 by 20) label="Cumulative Incidence (%)";
  xaxistable AtRisk / x=tAtRisk class=GROUP location=inside  colorgroup=GROUP separator ;
  keylegend "GRP" / location=inside position=topright;
run ;
